program sign;
{

  ("`-''-/").___..--''"`-._
 `6_ 6  )   `-.  (     ).`-.__.`)
 (_Y_.)'  ._   )  `._ `. ``-..-'
  _..`--'_..-_/  /--'_.' ,'
(il).-''  (li).'  ((!.-'

 CRC-32 Application Signer (for helper2.exe)
 !! INTERNAL BUILD !! FPC VERSION !!

 Copyright © 2008-2010 Denis Fateyev (Денис Фатеев)
 Website: <http://www.fateyev.com>
 E-mail: <denis@fateyev.com>

}
{$IFDEF FPC}
 {$MODE DELPHI}
{$ENDIF}

//-----------------------------------------------------
uses Windows, crc32;

//-----------------------------------------------------
const
 dwSaltValue = $FEEDBEEF;

//-----------------------------------------------------
var
 strFileProcess: string;
 sectCalc: PSectionsInfo;

//-----------------------------------------------------
begin
 if ( ParamCount < 1 ) then Halt( 1 );
 New( sectCalc );
 sectCalc[0].bIndex:= 0; // .text
 sectCalc[1].bIndex:= 1; // .data
 sectCalc[2].bIndex:= 4; // .rsrc
 strFileProcess:= ParamStr( 1 );
 CorrectCrc32File_Sections( PChar( strFileProcess ), PChar( strFileProcess + '.result.exe' ), sectCalc, 3, dwSaltValue );
 Dispose( sectCalc );
end.
